/*

Copyleft (L) 2004-2005  AlterWare Beast Inc.   >;->

Module Name:        DbgPrnHk.cpp
Abstract:           
Authors:            Alter
Environment:        kernel mode only

 */

#include "DbgPrnHk.h"
//#include "bin_patch.h"
#include "regtools.h"

PDRIVER_OBJECT DriverObject;
PDEVICE_OBJECT DbgPrnHkDevice = NULL;

UNICODE_STRING      unicodeDeviceNameDos;

CHAR Copyright[] = "DbgPrint hook driver v0.5"  PROD_VER_SUB " Copyright (c) 2004-2005 by Alexander A. Telyatnikov\n"
                   "home site: http://alter.org.ua\n";

//PCHAR Buffer = NULL;

/*
PDbgPrnHk_GetMessages_USER_OUT MsgBuffer = NULL;
LARGE_INTEGER ReadPosition = {0, 0};
LARGE_INTEGER WritePosition = {0, 0};
ULONG BufferSize = 1024*1024;
ULONG BufferSizeMask = (1024*1024/sizeof(DbgPrnHk_GetMessages_USER_OUT))-1;
ULONG QueueSize = 0;
ULONG MaxQueueSize = 0;
BOOLEAN CheckIrql = TRUE;
BOOLEAN NoPassMsgDown = FALSE;
BOOLEAN StopOnBufferOverflow = FALSE;
BOOLEAN LoggingPaused = FALSE;
*/

DBGPRNHK_INTERNAL_STATE st;

extern "C" {
PDBGPRNHK_INTERNAL_STATE DbgPrnHk_State = &st;
};

__int64       RdtscTimeStampCalibration0 = 0;
LARGE_INTEGER SysTimeStampCalibration0   = {0,0};
__int64       RdtscTimeStampCalibration  = 0;
LARGE_INTEGER SysTimeStampCalibration    = {0,0};

typedef
ULONG
(*PDBG_PRINT_API) (
    PCH Format,
    ...
    );

typedef
NTSTATUS
(*PDEBUG_PRINT_API) (
    IN PSTRING Output
    );

typedef
NTSTATUS
(*PDEBUG_PRINTEX_API) (
    IN PSTRING Output,
    IN ULONG Arg1,
    IN ULONG Arg2
    );

PDBG_PRINT_API     OrigDbgPrint = NULL;
PDEBUG_PRINT_API   OrigDebugPrint = NULL;
PDEBUG_PRINTEX_API OrigDebugPrintEx = NULL;
PUCHAR             PatchAddress = NULL;
PVOID              pvDbgPrintExWithPrefix = NULL;

NTSTATUS
HookDebugPrint (
    IN PSTRING Output
    );

NTSTATUS
HookDebugPrintEx (
    IN PSTRING Output,
    IN ULONG Arg1,
    IN ULONG Arg2
    );

VOID
PrintToBuffer(
    PDbgPrnHk_PostMessageEx_USER_IN MsgBuffer, /* optional */
    PCHAR Text,
    ULONG Length,
    UCHAR CallerMode
    );

ULONG
ReadFromBuffer(
    IN OUT PDbgPrnHk_GetMessages_USER_OUT UserBuffer,
    IN ULONG Length
    );

PVOID
KernelGetModuleBase(
    PCHAR  pModuleName
    );

PVOID
KernelGetProcAddress(
    PVOID ModuleBase,
    PCHAR pFunctionName
    );

NTSTATUS
DbgPrnHkReadRegistry();

ULONG  MajorVersion = 0;
ULONG  MinorVersion = 0;
ULONG  BuildNumber  = 0;


#define WinVer_IsNT   (MajorVersion==0x04)
#define WinVer_Is2k   (MajorVersion==0x05 && MinorVersion==0x00)
#define WinVer_IsXP   (MajorVersion==0x05 && MinorVersion==0x01)
#define WinVer_IsXPp  (MajorVersion==0x05 && MinorVersion>=0x01)
#define WinVer_IsdNET (MajorVersion==0x05 && MinorVersion==0x02)

__declspec (naked)
__int64
__fastcall
QueryRdtscPerformanceCounter()
{
  _asm {
    rdtsc
    ret
  }
}


/*
    DriverObject - Driver object.

    Returns:    NTSTATUS
 */

NTSTATUS
DriverEntry(
    IN PDRIVER_OBJECT driverObject,
    IN PUNICODE_STRING RegistryPath
    )
{
    CCHAR       deviceNameBuffer[MAXIMUM_FILENAME_LENGTH];
    CCHAR       deviceNameBufferDos[MAXIMUM_FILENAME_LENGTH];
    ANSI_STRING         deviceName;
    ANSI_STRING         deviceNameDos;
    UNICODE_STRING      unicodeDeviceName;
    ULONG               i;
    NTSTATUS            status;
    PVOID               ModuleBase;
//    BOOL bRet;
    ULONG               count_50_e8;
    PUCHAR              f_ptr;
    BOOLEAN             found = FALSE;

//    __asm int 3;
    //HalDisplayString((PUCHAR)"DbgPrnHk entry\n");

    // Init driver state
    memset(&st, 0, sizeof(st));

    st.Ver.Major = PROD_VER_MJ;
    st.Ver.Minor = PROD_VER_MN;
    st.Ver.Sub   = PROD_VER_NSUB;

    st.MsgBuffer = NULL;
    st.ReadPosition.QuadPart = 0;
    st.WritePosition.QuadPart = 0;
    st.BufferSize = 1024*1024;
    st.BufferSizeMask = (1024*1024/sizeof(DbgPrnHk_GetMessages_USER_OUT))-1;
    st.QueueSize = 0;
    st.MaxQueueSize = 0;
    st.CheckIrql = TRUE;
    st.NoPassMsgDown = FALSE;
    st.StopOnBufferOverflow = FALSE;
    st.LoggingPaused = FALSE;
    st.TimeStampType = TimeStampType_SysPerfCounter;

    // Init driver object & K
    DriverObject = driverObject;
    PsGetVersion(&MajorVersion, &MinorVersion, &BuildNumber, NULL);
    KdPrint(("DbgPrnHkInitialize: OS ver %x.%x (%d)\n", MajorVersion, MinorVersion, BuildNumber));

    for(i=0; i<=IRP_MJ_MAXIMUM_FUNCTION; i++)
        DriverObject->MajorFunction[i] = NULL;

    // Set up the device driver entry points.
    DriverObject->MajorFunction[IRP_MJ_CREATE] = DbgPrnHkCreateClose;
    DriverObject->MajorFunction[IRP_MJ_CLEANUP] = DbgPrnHkCreateClose;
    DriverObject->MajorFunction[IRP_MJ_CLOSE] = DbgPrnHkCreateClose;
    DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = DbgPrnHkDeviceControl;

    DriverObject->DriverUnload = DbgPrnHkUnload;

    sprintf((PCHAR)&deviceNameBuffer, NT_DbgPrnHk_NAME);
    KdPrint(("DbgPrnHkInitialize: Checking \\Device\\DbgPrnHk\n"));
    RtlInitAnsiString(&deviceName, (PCHAR)&deviceNameBuffer);
    RtlAnsiStringToUnicodeString(&unicodeDeviceName, &deviceName, TRUE);
    // Create the device object for DbgPrnHk.
    //HalDisplayString((PUCHAR)"DbgPrnHk: IoCreateDevice()\n");
    status = IoCreateDevice(DriverObject, 0 /*sizeof(LM_DEVICE_EXTENSION)*/, &unicodeDeviceName,
                        FILE_DEVICE_UNKNOWN, NULL, FALSE, &DbgPrnHkDevice);
    if(!NT_SUCCESS(status)) {
        //HalDisplayString((PUCHAR)"DbgPrnHk: IoCreateDevice() failed\n");
        RtlFreeUnicodeString(&unicodeDeviceName);
        return status;
    }

    sprintf((PCHAR)&deviceNameBufferDos, NT_DbgPrnHk_DOS_NAME);
    KdPrint(("DbgPrnHkInitialize: Checking \\DosDevices\\DbgPrnHk\n"));
    RtlInitAnsiString(&deviceNameDos, (PCHAR)&deviceNameBufferDos);
    RtlAnsiStringToUnicodeString(&unicodeDeviceNameDos, &deviceNameDos, TRUE);
    //HalDisplayString((PUCHAR)"DbgPrnHk: IoCreateSymbolicLink()\n");
    status = IoCreateSymbolicLink (&unicodeDeviceNameDos, &unicodeDeviceName);
    if(!NT_SUCCESS(status)) {
        //HalDisplayString((PUCHAR)"DbgPrnHk: IoCreateSymbolicLink() failed\n");
        IoDeleteDevice(DbgPrnHkDevice);
        RtlFreeUnicodeString(&unicodeDeviceName);
        RtlFreeUnicodeString(&unicodeDeviceNameDos);
        return status;
    }
    RtlFreeUnicodeString(&unicodeDeviceName);

    // get NTOSKRNL.EXE exports
    //HalDisplayString((PUCHAR)"DbgPrnHk: KernelGetModuleBase()\n");
    ModuleBase = KernelGetModuleBase ("NTOSKRNL.EXE");
    KdPrint(("DbgPrnHkInitialize: NTOSKRNL.EXE ModuleBase %#x\n", ModuleBase));
    if(ModuleBase) {
        //HalDisplayString((PUCHAR)"DbgPrnHk: KernelGetProcAddress(DbgPrint)\n");
        OrigDbgPrint = (PDBG_PRINT_API)KernelGetProcAddress(ModuleBase, "DbgPrint");
        //HalDisplayString((PUCHAR)"DbgPrnHk: KernelGetProcAddress(vDbgPrintExWithPrefix)\n");
        pvDbgPrintExWithPrefix = KernelGetProcAddress(ModuleBase, "vDbgPrintExWithPrefix");
    }
    KdPrint(("DbgPrnHkInitialize: DbgPrint              Address %#x\n", OrigDbgPrint));
    KdPrint(("DbgPrnHkInitialize: vDbgPrintExWithPrefix Address %#x\n", pvDbgPrintExWithPrefix));
    if(OrigDbgPrint) {
        KdDump(OrigDbgPrint, 0x100);
    }

    // get buffer size
    // Note, BufferSize must be power of 2
    st.BufferSize = 1024*1024;

    //HalDisplayString((PUCHAR)"DbgPrnHk: RegGetKeyHandle()\n");
    status = DbgPrnHkReadRegistry();

    //HalDisplayString((PUCHAR)"DbgPrnHk: open reg ok 2\n");

    st.BufferSizeMask = st.BufferSize / sizeof(DbgPrnHk_GetMessages_USER_OUT) - 1;
    st.MaxQueueSize = st.BufferSizeMask-1; // keep 2 reserved empty items
    st.MsgBuffer = (PDbgPrnHk_GetMessages_USER_OUT)
        ExAllocatePool(NonPagedPool, st.BufferSize);
    if(!st.MsgBuffer) {
        //HalDisplayString((PUCHAR)"DbgPrnHk: !MsgBuffer\n");
        DbgPrnHkUnload(DriverObject);
        return STATUS_INSUFFICIENT_RESOURCES;
    }

    if(pvDbgPrintExWithPrefix) {
        /*
          Under XP/2003 DebugPrint is called from vDbgPrintExWithPrefix() function.
          The ASM code of this call looks like this:

          PUSH EAX
          CALL xxxxxxxx
          CMP EAX,0x80000003

          We shall look for corresponding byte sequence
        */
        //HalDisplayString((PUCHAR)"Mode XP\n");
        KdPrint(("Mode XP\n"));
        f_ptr = (PUCHAR)pvDbgPrintExWithPrefix;
        KdPrint(("search @ %#x\n", f_ptr));
        for(i=0; i<0xff; i++) {
            if(f_ptr[i]   == 0x50 &&
               f_ptr[i+1] == 0xe8 &&
               f_ptr[i+6] == 0x3d &&
               (*(PULONG)(f_ptr+i+7)) == 0x80000003) {
                found = TRUE;
                break;
            }
        }
    } else
    if(MajorVersion == 5) {
        /*
          Under 2000 DebugPrint is called from DbgPrint() function.
          The ASM code of this call looks like this (same as XP):

          PUSH EAX
          CALL xxxxxxxx
          CMP EAX,0x80000003

          We shall look for corresponding byte sequence
        */
        //HalDisplayString((PUCHAR)"Mode v5\n");
        KdPrint(("Mode v5\n"));
        f_ptr = (PUCHAR)OrigDbgPrint;
        KdPrint(("search @ %#x\n", f_ptr));
        for(i=0; i<0xff; i++) {
            if(f_ptr[i]   == 0x50 &&
               f_ptr[i+1] == 0xe8 &&
               f_ptr[i+6] == 0x3d &&
               (*(PULONG)(f_ptr+i+7)) == 0x80000003) {
                found = TRUE;
                break;
            }
        }
    } else {
        /*
          Under NT4 DebugPrint is called from DbgPrint() function.
          The ASM code of this call looks like this (same as XP):

          PUSH EAX
          CALL xxxxxxxx

          this call is preceded with very similar call to vsnprintf():

          PUSH EAX
          CALL yyyyyyyy

          We shall look for the 2nd PUSH EAX/CALL xxxxxxxx byte sequence
        */
        //HalDisplayString((PUCHAR)"Mode other\n");
        KdPrint(("Mode other\n"));
        f_ptr = (PUCHAR)OrigDbgPrint;
        KdPrint(("search @ %#x\n", f_ptr));
        count_50_e8 = 0;
        for(i=0; i<0xff; i++) {
            if(f_ptr[i]   == 0x50 &&
               f_ptr[i+1] == 0xe8) {
                count_50_e8++;
                if(count_50_e8 == 2) {
                    found = TRUE;
                    break;
                }
            }
        }
    }
    if(!found) {
        //HalDisplayString((PUCHAR)"DbgPrnHk: entry point not found\n");
        DbgPrnHkUnload(DriverObject);
        return STATUS_INSUFFICIENT_RESOURCES;
    }

    //HalDisplayString((PUCHAR)"make patch\n");
    KdPrint(("DbgPrnHkInitialize: Patching call to DebugPrint @ %#x\n", f_ptr+i+2));
    //========================================
    // Clear WriteProtection bit in CR0:
    _asm pushad
    _asm mov  ebx, cr0
    _asm push ebx
    _asm and  ebx, ~0x10000  // reset WriteProtect bit
    _asm mov  cr0, ebx

    _asm pushfd
    _asm cli

    PatchAddress = f_ptr+i+2;
    // save CALL address (relative)
    OrigDebugPrint = (PDEBUG_PRINT_API)(*(PULONG)(PatchAddress) + (ULONG)(PatchAddress+4));
    KdPrint(("DbgPrnHkInitialize: orig call addr %#x\n", OrigDebugPrint));
    if(pvDbgPrintExWithPrefix) {
        KdPrint(("DbgPrnHkInitialize: XP KdPrintEx\n"));
        OrigDebugPrintEx = (PDEBUG_PRINTEX_API)OrigDebugPrint;
        // patch CALL address (relative)
        *(PULONG)(PatchAddress) = (ULONG)HookDebugPrintEx - (ULONG)(PatchAddress+4);
    } else {
        KdPrint(("DbgPrnHkInitialize: std KdPrint\n"));
        // patch CALL address (relative)
        *(PULONG)(PatchAddress) = (ULONG)HookDebugPrint - (ULONG)(PatchAddress+4);
    }

    _asm popfd

    // Restore WriteProtection bit in CR0:
    _asm pop ebx
    _asm mov cr0, ebx
    _asm popad

    //HalDisplayString((PUCHAR)"Patched...\n");
    KdPrint(("DbgPrnHkInitialize: Patched...\n"));

    __try {
        RdtscTimeStampCalibration0 = QueryRdtscPerformanceCounter();
    } __except(EXCEPTION_EXECUTE_HANDLER) {
        RdtscTimeStampCalibration0 = 0;
        if(st.TimeStampType == TimeStampType_RdtscPerfCounter) {
            st.TimeStampType = TimeStampType_SysTime;
        }
    }
    SysTimeStampCalibration0 = KeQueryPerformanceCounter(NULL);

    KdPrint(("DbgPrnHkInitialize: RDTSC %I64d, SYS  %I64d\n", RdtscTimeStampCalibration0, SysTimeStampCalibration0.QuadPart));

    return STATUS_SUCCESS;

} // DriverEntry()

/*
    This routine services open commands. It establishes
    the driver's existance by returning status success.

    Arguments:

    DeviceObject - Context for the activity.
    Irp          - The device control argument block.

    Returns:    NT Status
 */
NTSTATUS
DbgPrnHkCreateClose(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    return STATUS_SUCCESS;
} // end DbgPrnHkCreateClose()


/*
    This device control dispatcher handles only the disk performance
    device control. All others are passed down to the disk drivers.
    The disk performane device control returns a current snapshot of
    the performance data.

    Arguments:

    DeviceObject - Context for the activity.
    Irp          - The device control argument block.

    Returns:    NT Status
 */
NTSTATUS
DbgPrnHkDeviceControl(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp
    )
{
//    KdPrint(("DbgPrnHkDeviceControl\n"));
//    PLM_DEVICE_EXTENSION deviceExtension = (PLM_DEVICE_EXTENSION)DeviceObject->DeviceExtension;
    PIO_STACK_LOCATION  irpStack = IoGetCurrentIrpStackLocation(Irp);
    ULONG               ioctlCode;
    NTSTATUS            status;
    ULONG               length;

    Irp->IoStatus.Information = 0;
    ioctlCode = irpStack->Parameters.DeviceIoControl.IoControlCode;
    switch (ioctlCode) {
    case IOCTL_DbgPrnHk_GetMessages: {
        //KdPrint(("DbgPrnHk: GetMessages\n"));
        // We have <DeviceName> & its attributes.
        PDbgPrnHk_GetMessages_USER_OUT obuffer;

        length = sizeof(DbgPrnHk_GetMessages_USER_OUT); 
        CHECK_OUT_BUFFER();

        obuffer = (PDbgPrnHk_GetMessages_USER_OUT)(Irp->AssociatedIrp.SystemBuffer);

        length = ReadFromBuffer(obuffer,
            irpStack->Parameters.DeviceIoControl.OutputBufferLength);

        Irp->IoStatus.Information = length;
        status = STATUS_SUCCESS;
        break;
    }
    case IOCTL_DbgPrnHk_GetVersion: {
        //PDbgPrnHk_GetVersion_USER_OUT obuffer;

        length = sizeof(DbgPrnHk_GetVersion_USER_OUT); 
        CHECK_OUT_BUFFER();

/*
        obuffer = (PDbgPrnHk_GetVersion_USER_OUT)(Irp->AssociatedIrp.SystemBuffer);
        obuffer->Major = PROD_VER_MJ;
        obuffer->Minor = PROD_VER_MN;
        obuffer->Sub   = PROD_VER_NSUB;
*/
        memcpy(Irp->AssociatedIrp.SystemBuffer, &st.Ver, sizeof(DbgPrnHk_GetVersion_USER_OUT));

        Irp->IoStatus.Information = length;
        status = STATUS_SUCCESS;
        break;
    }
    case IOCTL_DbgPrnHk_PostMessage: {

        length = irpStack->Parameters.DeviceIoControl.InputBufferLength;

        PrintToBuffer(NULL, (PCHAR)(Irp->AssociatedIrp.SystemBuffer), length, 1);

        Irp->IoStatus.Information = length;
        status = STATUS_SUCCESS;
        break;
    }
    case IOCTL_DbgPrnHk_GetRdtscCalibration: {
        PDbgPrnHk_GetRdtscCalibration_USER_IN  ibuffer;
        PDbgPrnHk_GetRdtscCalibration_USER_OUT obuffer;

        length = irpStack->Parameters.DeviceIoControl.InputBufferLength;
        if(length) {
            length = sizeof(DbgPrnHk_GetRdtscCalibration_USER_IN);
            CHECK_IN_BUFFER();
            ibuffer = (PDbgPrnHk_GetRdtscCalibration_USER_IN)(Irp->AssociatedIrp.SystemBuffer);
            if(ibuffer->Recalibrate) {
                RdtscTimeStampCalibration = QueryRdtscPerformanceCounter();
                SysTimeStampCalibration   = KeQueryPerformanceCounter(NULL);

                //KdPrint(("DbgPrnHkDeviceControl: RDTSC %I64d, SYS  %I64d\n", RdtscTimeStampCalibration, SysTimeStampCalibration.QuadPart));
            }
            if(ibuffer->ChangeType) {
                if(ibuffer->TimeStampType > TimeStampType_Max) {
                    status = STATUS_INVALID_PARAMETER;
                    break;
                }
                st.TimeStampType = ibuffer->TimeStampType;
            }
        }

        length = irpStack->Parameters.DeviceIoControl.OutputBufferLength;
        if(length) {
            length = sizeof(DbgPrnHk_GetRdtscCalibration_USER_OUT);
            CHECK_OUT_BUFFER();
            if(!RdtscTimeStampCalibration && !SysTimeStampCalibration.QuadPart) {
                __try {
                    RdtscTimeStampCalibration = QueryRdtscPerformanceCounter();
                } __except(EXCEPTION_EXECUTE_HANDLER) {
                    RdtscTimeStampCalibration = 0;
                    if(st.TimeStampType == TimeStampType_RdtscPerfCounter) {
                        st.TimeStampType = TimeStampType_SysTime;
                    }
                }
                SysTimeStampCalibration   = KeQueryPerformanceCounter(NULL);
            }
            obuffer = (PDbgPrnHk_GetRdtscCalibration_USER_OUT)(Irp->AssociatedIrp.SystemBuffer);
            obuffer->RdtscTimeStampCalibration0 = RdtscTimeStampCalibration0;
            obuffer->SysTimeStampCalibration0   = SysTimeStampCalibration0.QuadPart;
            obuffer->RdtscTimeStampCalibration  = RdtscTimeStampCalibration;
            obuffer->SysTimeStampCalibration    = SysTimeStampCalibration.QuadPart;
            obuffer->TimeStampType              = st.TimeStampType;
        }

        Irp->IoStatus.Information = length;
        status = STATUS_SUCCESS;
        break;
    }
    case IOCTL_DbgPrnHk_GetRdtsc: {
        PLONGLONG obuffer;

        length = sizeof(LONGLONG);
        CHECK_OUT_BUFFER();

        obuffer = (PLONGLONG)(Irp->AssociatedIrp.SystemBuffer);
        __try {
            (*obuffer) = QueryRdtscPerformanceCounter();
        } __except(EXCEPTION_EXECUTE_HANDLER) {
            status = STATUS_ILLEGAL_INSTRUCTION;
            break;
        }
        
        Irp->IoStatus.Information = length;
        status = STATUS_SUCCESS;
        break;
    }
    case IOCTL_DbgPrnHk_CanUnload: {
        ULONG Addr;

        if(pvDbgPrintExWithPrefix) {
            Addr = (ULONG)HookDebugPrintEx - (ULONG)(PatchAddress+4);
        } else {
            Addr = (ULONG)HookDebugPrint - (ULONG)(PatchAddress+4);
        }
        if(*(PULONG)(PatchAddress) == Addr) {
            status = STATUS_SUCCESS;
        } else {
            status = STATUS_UNSUCCESSFUL;
        }
        
        break;
    }
    case IOCTL_DbgPrnHk_PostMessageEx: {

        length = irpStack->Parameters.DeviceIoControl.InputBufferLength;

        PrintToBuffer((PDbgPrnHk_PostMessageEx_USER_IN)(Irp->AssociatedIrp.SystemBuffer),
            NULL,
            length - offsetof(DbgPrnHk_PostMessageEx_USER_IN, Msg),
            1);
        //status = PutToBuffer((PDbgPrnHk_GetMessages_USER_OUT)(Irp->AssociatedIrp.SystemBuffer), NULL, 0);

        Irp->IoStatus.Information = 0;
        status = STATUS_SUCCESS;
        break;
    }
    default:

        status = STATUS_INVALID_DEVICE_REQUEST;
        break;
    }

DbgPrnHkSpecDevCtrlCompleteRequest:

    Irp->IoStatus.Status = status;    // Update IRP with completion status.
    IoCompleteRequest(Irp, IO_DISK_INCREMENT);    // Complete the request.
//    KdPrint(( "DbgPrnHkDeviceControl: Status is %lx\n", status));
    return status;

} // end DbgPrnHkDeviceControl()


/*
    This routine services driver unload commands.

    Arguments:

    DeviceObject - Context for the activity.

    Returns:    none
 */
VOID
DbgPrnHkUnload(
    IN PDRIVER_OBJECT DriverObject
    )
{
    LARGE_INTEGER Delay;
    ULONG Addr;

    Delay.QuadPart = -10*1000*1000; // 1 sec

    if(pvDbgPrintExWithPrefix) {
        KdPrint(("DbgPrnHkInitialize: Prepare to Unpatch XP KdPrintEx\n"));
        Addr = (ULONG)HookDebugPrintEx - (ULONG)(PatchAddress+4);
    } else {
        Addr = (ULONG)HookDebugPrint - (ULONG)(PatchAddress+4);
    }

    while(PatchAddress) {
        if(*(PULONG)(PatchAddress) == Addr) {
            KdPrint(("DbgPrnHkInitialize: UnPatching call to DebugPrint @ %#x\n", PatchAddress-2));
            //========================================
            // Clear WriteProtection bit in CR0:
            _asm pushad
            _asm mov  ebx, cr0
            _asm push ebx
            _asm and  ebx, ~0x10000  // reset WriteProtect bit
            _asm mov  cr0, ebx

            _asm pushfd
            _asm cli

            // restore CALL address (relative)
            if(pvDbgPrintExWithPrefix) {
                KdPrint(("DbgPrnHkInitialize: Unpatch XP KdPrintEx\n"));
                *(PULONG)(PatchAddress) = (ULONG)OrigDebugPrintEx - (ULONG)(PatchAddress+4);
            } else {
                *(PULONG)(PatchAddress) = (ULONG)OrigDebugPrint - (ULONG)(PatchAddress+4);
            }

            _asm popfd

            // Restore WriteProtection bit in CR0:
            _asm pop ebx
            _asm mov cr0, ebx
            _asm popad

            KdPrint(("DbgPrnHkInitialize: UnPatched...\n"));
            break;
        }
        KdPrint(("DbgPrnHkInitialize: wait for Unpatch...\n"));
        KeDelayExecutionThread(KernelMode, FALSE, &Delay);
    }

    if(st.MsgBuffer)
        ExFreePool(st.MsgBuffer);

    IoDeleteSymbolicLink(&unicodeDeviceNameDos);
    
    RtlFreeUnicodeString(&unicodeDeviceNameDos);

    if(DbgPrnHkDevice) {
        IoDeleteDevice(DbgPrnHkDevice);
        DbgPrnHkDevice = NULL;
    }
    return;
} // end DbgPrnHkUnload()

PDbgPrnHk_GetMessages_USER_OUT
GetBufferItem()
{
    ULONG PrevPos;
    ULONG i;
    ULONG qs;

    if(st.StopOnBufferOverflow) {
        qs = InterlockedIncrement((PLONG)&st.QueueSize);
        if(qs >= st.MaxQueueSize) {
            InterlockedDecrement((PLONG)&st.QueueSize);
            return NULL;
        }
    }
    PrevPos = InterlockedIncrement((PLONG)&st.WritePosition.LowPart);
    if(!(PrevPos)) {
        InterlockedIncrement((PLONG)&st.WritePosition.HighPart);
    }
    PrevPos--;
    i = PrevPos & st.BufferSizeMask;
    if(st.WritePosition.HighPart > st.ReadPosition.HighPart) {
        if(st.WritePosition.LowPart >= st.ReadPosition.LowPart) {
            st.ReadPosition.QuadPart = st.WritePosition.QuadPart+1;
        }
    } else
    if(((i+1) & st.BufferSizeMask) == (st.ReadPosition.LowPart & st.BufferSizeMask)) {
        PrevPos = InterlockedIncrement((PLONG)&st.ReadPosition.LowPart);
        if(!(PrevPos)) {
            InterlockedIncrement((PLONG)&st.ReadPosition.HighPart);
        }
    }
    return &st.MsgBuffer[i];
} // end GetBufferItem()

LONGLONG
GetTimeStamp()
{
    LONGLONG TimeStamp;
    switch(st.TimeStampType) {
    case TimeStampType_SysPerfCounter:
        return (LONGLONG)(KeQueryPerformanceCounter(NULL).QuadPart);

    case TimeStampType_RdtscPerfCounter:
        return QueryRdtscPerformanceCounter();

    case TimeStampType_SysTime:
        //MsgBuffer_i->TimeStamp.QuadPart = QueryRdtscPerformanceCounter();
        KeQuerySystemTime((PLARGE_INTEGER)&TimeStamp);
        return TimeStamp;
    }
    return 0;
} // end GetTimeStamp()
/*
NTSTATUS
PutToBuffer(
    PDbgPrnHk_GetMessages_USER_OUT MsgBuffer,
    PCHAR Text, // optional
    ULONG Length // must be 0 if Text == NULL
    )
{
    ULONG to_write;
    PDbgPrnHk_GetMessages_USER_OUT MsgBuffer_i;

    MsgBuffer_i = GetBufferItem();
    if(!MsgBuffer_i) {
        return STATUS_BUFFER_TOO_SMALL;
    }

    __try {
        if(!MsgBuffer->TimeStamp.QuadPart) {
            MsgBuffer->TimeStamp.QuadPart = GetTimeStamp();
        }
        if(Text) {
            to_write = min(Length, MAX_MSG_SIZE);
            if(MsgBuffer) {
                memcpy(MsgBuffer_i, MsgBuffer, offsetof(DbgPrnHk_GetMessages_USER_OUT, Msg));
            } else {
                return STATUS_INVALID_USER_BUFFER;
            }
            MsgBuffer_i->Length = (USHORT)to_write;
            memcpy(&MsgBuffer_i->Msg[0], Text, to_write);
        } else {
            memcpy(MsgBuffer_i, MsgBuffer, sizeof(DbgPrnHk_GetMessages_USER_OUT));
            MsgBuffer_i->Length = min(MsgBuffer_i->Length, MAX_MSG_SIZE);
        }
    } __except(EXCEPTION_EXECUTE_HANDLER) {
        MsgBuffer_i->Length = 0;
        return STATUS_INVALID_USER_BUFFER;
    }

    return STATUS_SUCCESS;
} // end PutToBuffer()
*/

__declspec (naked)
PVOID
__stdcall
GetCurrentPEB(void) 
{
  _asm {
    mov eax,fs:[124h]
    ret
  }
}

VOID
PrintToBuffer(
    IN PDbgPrnHk_PostMessageEx_USER_IN MsgBuffer, /* optional */
    IN PCHAR Text,
    IN ULONG Length,
    IN UCHAR CallerMode
    )
{
    ULONG to_write;
    PDbgPrnHk_GetMessages_USER_OUT MsgBuffer_i;
    UCHAR CpuNumber;

    LONGLONG TimeStamp;
    //BOOLEAN CallerMode = (ExGetPreviousMode() == UserMode);

    if(!MsgBuffer) {
        if(!Text)
            return;
        TimeStamp = GetTimeStamp();
        CpuNumber = (UCHAR)KeGetCurrentProcessorNumber();
    } else {
        if(!MsgBuffer->TimeStamp.QuadPart) {
            MsgBuffer->TimeStamp.QuadPart = GetTimeStamp();
        }
        if(!Text) {
            Text = MsgBuffer->Msg;
            Length = min(MsgBuffer->Length, Length);
        }
    }

    //HalDisplayString((PUCHAR)Text);
    while(Length)  {

        MsgBuffer_i = GetBufferItem();
        if(!MsgBuffer_i) {
            return;
        }

        to_write = min(Length, MAX_MSG_SIZE);

        if(!MsgBuffer) {
            if(GetCurrentPEB()) {
                MsgBuffer_i->ProcessId = PsGetCurrentProcessId();
                MsgBuffer_i->ThreadId  = PsGetCurrentThreadId();
            } else /*__except(EXCEPTION_EXECUTE_HANDLER)*/ {
                // some API hook tools call DbgPrint having invalid FS
                // this will cause page fault inside PsGetXxx()
                MsgBuffer_i->ProcessId = (PVOID)0xffffffff;
                MsgBuffer_i->ThreadId  = (PVOID)0xffffffff;
            }
            MsgBuffer_i->Irql      = KeGetCurrentIrql();
            MsgBuffer_i->CpuNumber = CpuNumber;
            MsgBuffer_i->TimeStamp.QuadPart = TimeStamp;
            memset((&MsgBuffer_i->Reserved[0])-1, 0, 4);
            MsgBuffer_i->TimeStampType = st.TimeStampType;
            MsgBuffer_i->CallerMode    = CallerMode ? 1 : 0;

            MsgBuffer_i->Length    = (USHORT)to_write;
            __try {
                memcpy(&MsgBuffer_i->Msg[0], Text, to_write);
            } __except(EXCEPTION_EXECUTE_HANDLER) {
                MsgBuffer_i->Length = 0;
                break;
            }
        } else {
            __try {
                if(!MsgBuffer->TimeStamp.QuadPart) {
                    MsgBuffer_i->TimeStamp.QuadPart = TimeStamp;
                }
                memcpy(MsgBuffer_i, MsgBuffer, offsetof(DbgPrnHk_GetMessages_USER_OUT, Msg));
                memcpy(MsgBuffer_i->Msg, Text, to_write);
                MsgBuffer_i->Length = (USHORT)to_write;
            } __except(EXCEPTION_EXECUTE_HANDLER) {
                MsgBuffer_i->Length = 0;
                return;
            }
        }

        Text += to_write;
        Length -= to_write;
    }
    return;
} // end PrintToBuffer()

ULONG
ReadFromBuffer(
    IN OUT PDbgPrnHk_GetMessages_USER_OUT UserBuffer,
    IN ULONG Length
    )
{
    ULONG PrevPos;
    ULONG i;
    ULONG to_write = 0;

    while(Length >= sizeof(DbgPrnHk_GetMessages_USER_OUT))  {
        if(st.ReadPosition.QuadPart >= st.WritePosition.QuadPart) {
            break;
        }
        PrevPos = InterlockedIncrement((PLONG)&st.ReadPosition.LowPart);
        if(!(PrevPos)) {
            InterlockedIncrement((PLONG)&st.ReadPosition.HighPart);
        }
        PrevPos--;
        i = PrevPos & st.BufferSizeMask;
        __try {
            memcpy(UserBuffer, &st.MsgBuffer[i], sizeof(DbgPrnHk_GetMessages_USER_OUT));
        } __except(EXCEPTION_EXECUTE_HANDLER) {
            break;
        }
        UserBuffer++;
        to_write += sizeof(DbgPrnHk_GetMessages_USER_OUT);
        Length -= sizeof(DbgPrnHk_GetMessages_USER_OUT);
        if(st.StopOnBufferOverflow) {
            InterlockedDecrement((PLONG)&st.QueueSize);
        }
    }
    return to_write;
} // end ReadFromBuffer()

#define IsMsgBlocked() \
    (st.NoPassMsgDown || \
     (st.CheckIrql && (KeGetCurrentIrql() > DISPATCH_LEVEL)) )
/*
BOOLEAN
IsMsgBlocked()
{
    if(NoPassMsgDown)
        return TRUE;
    if(CheckIrql && (KeGetCurrentIrql() > DISPATCH_LEVEL))
        return TRUE;
    return FALSE;
} // end IsMsgBlocked()
*/
NTSTATUS
HookDebugPrint(
    IN PSTRING Output
    )
{
    if(Output && !st.LoggingPaused)
        PrintToBuffer(NULL, Output->Buffer, Output->Length, 0);
    if(!OrigDebugPrint)
        return STATUS_SUCCESS;
    if(IsMsgBlocked())
        return STATUS_SUCCESS;
    return OrigDebugPrint(Output);
} // end HookDebugPrint()

NTSTATUS
HookDebugPrintEx(
    IN PSTRING Output,
    IN ULONG   Arg1,
    IN ULONG   Arg2
    )
{
    if(Output && !st.LoggingPaused) {
        PrintToBuffer(NULL, Output->Buffer, Output->Length, 0);
    }
    if(IsMsgBlocked())
        return STATUS_SUCCESS;
    return OrigDebugPrintEx(Output, Arg1, Arg2);
} //end HookDebugPrintEx()

PVOID
KernelGetModuleBase(
    PCHAR  pModuleName
    )
{
    PVOID pModuleBase = NULL;

    __try
    {
        NTSTATUS status = STATUS_INSUFFICIENT_RESOURCES;
        ULONG    SystemInfoBufferSize = 0;
        PULONG   pSystemInfoBuffer = NULL;

        status = ZwQuerySystemInformation(SystemModuleInfo,
            &SystemInfoBufferSize,
            0,
            &SystemInfoBufferSize);

        if (!SystemInfoBufferSize)
            return NULL;

        pSystemInfoBuffer = (PULONG)ExAllocatePool(NonPagedPool, SystemInfoBufferSize*2);

        if (!pSystemInfoBuffer)
            return NULL;

        memset(pSystemInfoBuffer, 0, SystemInfoBufferSize*2);

        status = ZwQuerySystemInformation(SystemModuleInfo,
            pSystemInfoBuffer,
            SystemInfoBufferSize*2,
            &SystemInfoBufferSize);

        if (NT_SUCCESS(status))
        {
            PSYSTEM_MODULE_ENTRY pSysModuleEntry =((PSYSTEM_MODULE_INFORMATION)(pSystemInfoBuffer))->Module;
            ULONG i;
            
            for (i = 0; i <((PSYSTEM_MODULE_INFORMATION)(pSystemInfoBuffer))->Count; i++)
            {
                if (_stricmp(pSysModuleEntry[i].ModuleName + pSysModuleEntry[i].ModuleNameOffset, pModuleName) == 0)
                {
                    pModuleBase = pSysModuleEntry[i].ModuleBaseAddress;
                    break;
                }
            }
        }

        ExFreePool(pSystemInfoBuffer);
    }
    __except(EXCEPTION_EXECUTE_HANDLER)
    {
        pModuleBase = NULL;
    }

    return pModuleBase;
} // end KernelGetModuleBase()

PVOID
KernelGetProcAddress(
    PVOID ModuleBase,
    PCHAR pFunctionName
    )
{
    PVOID pFunctionAddress = NULL;
    
    __try
    {
        PIMAGE_DOS_HEADER dos =(PIMAGE_DOS_HEADER) ModuleBase;
        PIMAGE_NT_HEADERS nt  =(PIMAGE_NT_HEADERS)((ULONG) ModuleBase + dos->e_lfanew);

        PIMAGE_DATA_DIRECTORY expdir =(PIMAGE_DATA_DIRECTORY) nt->OptionalHeader.DataDirectory + IMAGE_DIRECTORY_ENTRY_EXPORT;
        ULONG                 size = expdir->Size;
        ULONG                 addr = expdir->VirtualAddress;

        PIMAGE_EXPORT_DIRECTORY exports =(PIMAGE_EXPORT_DIRECTORY)((ULONG) ModuleBase + addr);

        PULONG functions =(PULONG)((ULONG) ModuleBase + exports->AddressOfFunctions);
        PSHORT ordinals  =(PSHORT)((ULONG) ModuleBase + exports->AddressOfNameOrdinals);
        PULONG names     =(PULONG)((ULONG) ModuleBase + exports->AddressOfNames);
        ULONG  max_name  =exports->NumberOfNames;
        ULONG  max_func  =exports->AddressOfFunctions;

        ULONG i;

        for (i = 0; i < exports->AddressOfNames; i++)
        {
            ULONG ord = ordinals[i];
            if(i >= max_name || ord >= max_func) {
                return NULL;
            }
            if (functions[ord] < addr || functions[ord] >= addr + size)
            {
                if (strcmp((PCHAR) ModuleBase + names[i], pFunctionName)  == 0)
                {
                    pFunctionAddress =(PVOID)((PCHAR) ModuleBase + functions[ord]);
                    break;
                }
            }
        }
    }
    __except(EXCEPTION_EXECUTE_HANDLER)
    {
        pFunctionAddress = NULL;
    }

    return pFunctionAddress;
} // end KernelGetProcAddress()

NTSTATUS
DbgPrnHkReadRegistry()
{
    NTSTATUS            status;
    HANDLE              hReg = NULL;
    ULONG               i;
    ULONG               tmp;

    status = RegGetKeyHandle(NULL, NT_DBGPRNHK_REG_PATH, &hReg);
    if(hReg) {

        //HalDisplayString((PUCHAR)"DbgPrnHk: open reg ok\n");
        
        st.BufferSize /= 1024;
        RegGetDword(hReg, NULL, NT_DBGPRNHK_REG_BUFFER_SIZE_VAL, &st.BufferSize);
        st.BufferSize *= 1024;
        i=0;
        while(st.BufferSize) {
            st.BufferSize >>= 1;
            i++;
        }
        if(i && i<10) {
            i--;
        } else {
            i = 10;
        }
        st.BufferSize = ((ULONG)1) << i;
        KdPrint(("DbgPrnHkInitialize: %s %#x\n", NT_DBGPRNHK_REG_BUFFER_SIZE_VAL, st.BufferSize));

        tmp = st.CheckIrql;
        RegGetDword(hReg, NULL, NT_DBGPRNHK_REG_CHECK_IRQL_VAL, &tmp);
        if(tmp) {
            st.CheckIrql = TRUE;
        }
        KdPrint(("DbgPrnHkInitialize: %s %#x\n", NT_DBGPRNHK_REG_CHECK_IRQL_VAL, st.CheckIrql));

        tmp = st.NoPassMsgDown;
        RegGetDword(hReg, NULL, NT_DBGPRNHK_REG_BLOCK_MSG_VAL, &tmp);
        if(tmp) {
            st.NoPassMsgDown = TRUE;
        }
        KdPrint(("DbgPrnHkInitialize: %s %#x\n", NT_DBGPRNHK_REG_BLOCK_MSG_VAL, st.NoPassMsgDown));

        tmp = st.StopOnBufferOverflow;
        RegGetDword(hReg, NULL, NT_DBGPRNHK_REG_STOP_OVERFLOW_VAL, &tmp);
        if(tmp) {
            st.StopOnBufferOverflow = TRUE;
        }
        KdPrint(("DbgPrnHkInitialize: %s %#x\n", NT_DBGPRNHK_REG_STOP_OVERFLOW_VAL, st.StopOnBufferOverflow));

        tmp = st.TimeStampType;
        RegGetDword(hReg, NULL, NT_DBGPRNHK_REG_TSTAMP_TYPE_VAL, &tmp);
        if(tmp <= TimeStampType_Max) {
            st.TimeStampType = (UCHAR)tmp;
        }
        KdPrint(("DbgPrnHkInitialize: %s %#x\n", NT_DBGPRNHK_REG_TSTAMP_TYPE_VAL, st.TimeStampType));

        ZwClose(hReg);
    }
    return status;
} // end DbgPrnHkReadRegistry()
